
TYPO3.Flow - Feature # 27499

Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: Property
Created: 2011-06-16 Assigned To: Sebastian Kurfuerst
Updated: 2011-06-24 Due date:
PHP Version:
Has patch:
Complexity:
Subject: Refactor TypeConverter API
Description

Currently TypeConverters support multiple source but only one target type.
As discussed with Robert, this should be changed so that you can specify an array of supported TargetTypes.
This makes especially sense when using TypeConverters independently from the PropertyMapper.

The TypeConverterInterface should be adjusted like:

-getSupportedTargetType()
+getSupportedTargetTypes()

@Sebastian I'm assigning this to you, because that should be changed before the backport of the PropertyMapper. Feel free to
unasign yourself if you can't to it atm ;)

Related issues:
related to TYPO3.Flow - Bug # 27611: Rename and combine TypeConverters Resolved 2011-06-21

Associated revisions
Revision 95dc5123 - 2011-06-23 15:05 - Sebastian Kurfuerst

[+BUGFIX] (Property): Refactor TypeConverter API

    -  canConvert -> canConvertFrom
    -  getProperties -> getSourceChildPropertiesToBeConverted
    -  getTypeOfProperty -> getTypeOfChildProperty
    -  $subProperties -> $convertedChildProperties

Resolves: #27499
Change-Id: I9128ab6edc4ee103f8c39bf25f35da296e0506f1

History
#1 - 2011-06-16 16:40 - Bastian Waidelich
- Subject changed from TypeConverters should support multiple target types to Support multiple target types in TypeConverters

#2 - 2011-06-16 16:40 - Robert Lemke
- Target version set to 1.0 beta 1

#3 - 2011-06-17 12:20 - Bastian Waidelich

Bastian Waidelich wrote:

2015-08-03 1/3



-getSupportedTargetType()
+getSupportedTargetTypes()

As mentioned in the scrum meeting, I'm not sure anymore whether that makes sense..
Instead we should strive for a one-converter-per-type approach IMO.

That way we could get rid of three of the existing converters:

ArrayCollectionConverter -> ArrayCollectionConverter
ArrayToArrayConverter -> ArrayConverter
ArrayToObjectConverter -> ObjectConverter
ArrayToSplObjectStorageConverter -> SplObjectStorageConverter
BooleanToBooleanConverter -> BooleanConverter
IntegerToIntegerConverter -> IntegerConverter
PersistentObjectConverter -> PersistentObjectConverter
StringToBooleanConverter -> (not needed anymore)
StringToFloatConverter -> FloatConverter
StringToIntegerConverter -> (not needed anymore)
StringToSplObjectStorageConverter -> (not needed anymore)
StringToStringConverter -> StringConverter

In the long run, we should add a convertTo() method for "reversed conversions"

#4 - 2011-06-20 12:14 - Sebastian Kurfuerst

change API: rename 'canConvert' to 'canConvertFrom' in TypeConverterInterface

#5 - 2011-06-23 12:17 - Mr. Hudson

Patch set 1 of change I9128ab6edc4ee103f8c39bf25f35da296e0506f1 has been pushed to the review server.
It is available at http://review.typo3.org/2895

#6 - 2011-06-23 12:20 - Sebastian Kurfuerst
- Status changed from New to Under Review
- % Done changed from 0 to 90

#7 - 2011-06-23 15:06 - Mr. Hudson

Patch set 2 of change I9128ab6edc4ee103f8c39bf25f35da296e0506f1 has been pushed to the review server.
It is available at http://review.typo3.org/2895

#8 - 2011-06-23 18:30 - Bastian Waidelich
- Subject changed from Support multiple target types in TypeConverters to Refactor TypeConverter API

    -  canConvert -> canConvertFrom
    -  getProperties -> getSourceChildPropertiesToBeConverted
    -  getTypeOfProperty -> getTypeOfChildProperty
    -  $subProperties -> $convertedChildProperties

#9 - 2011-06-24 11:37 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 90 to 100

Applied in changeset commit:95dc5123aaf742208061358e4316b7201783965e.
